BEGIN {
	print ".PS"
	print ".ps 6"
	print "copy \"schem.macros\""
	print "maxpsht=1000"
	print "maxpswid=2000"
}

END {
	print ".PE"
}

{lineno++ }

function shiftfields(n, i) {	# move $n+1..$NF to $n..$NF-1, zap $NF
	for (i = n; i < NF; i++)
		$i = $(i+1)
	$NF = ""
	NF--
}

function lettertoi(n) {
	if (n == "A") return 1;
	if (n == "B") return 2;
	if (n == "C") return 3;
	if (n == "D") return 4;
	if (n == "E") return 5;
	if (n == "F") return 6;
	if (n == "G") return 7;
	if (n == "H") return 8;
	if (n == "E") return 9;
	if (n == "F") return 10;
	if (n == "G") return 11;
	if (n == "H") return 12;
	if (n == "I") return 13;
	if (n == "J") return 14;
	if (n == "K") return 15;
	if (n == "L") return 16;
}

function sectorize(z) {
	sector_x = substr(z, 1,1);
	sector_y = deltasector_y * substr(z, 2,1);
	sector_x = deltasector_x * lettertoi(sector_x);
	sector = sprintf("%f,%f", sector_x, sector_y);
	return sector;
}
 

/.cktstart/ {
	#Defaults
	pagewid = 8.5;
	pageht = 11.0;
	nsector_x = 4.0;
	nsector_y = 6.0;
	deltasector_x = pagewid / (nsector_x + 1);
	deltasector_y = pageht / (nsector_y + 1);
}
$1 == "pic"	{ shiftfields(1); print; next }	# pic pass-thru
$1 ~ /^[A-Z].*:$/ {	 
	netname = substr($1, 1, length($1)-1)
	shiftfields(1)
}
$1 == "#" { print $0 }

$1 == ".nodename" {netname = $2; show_node = $3; next}
#{
#	if(in_net == 1 && !match($1,"#")){
#		gsub(/\*/,".P", $0);
#		gsub(/\~/,"_S", $0);
#		if($1 == "->"){ shiftfields(1); print $0; 
#		} else netlists = sprintf("%s %s", netlists, $0);
#	}
#}
	
$1 == "res" {dev = 1; shiftfields(1); device(); next}
$1 == "cap" {dev = 2; shiftfields(1); device(); next}
$1 == "bjt" {dev = 3; shiftfields(1); device(); next}
$1 == "ic" {dev = 4; shiftfields(1); device(); next}
$1 == "header" {dev = 5; shiftfields(1); device(); next}
$1 == "xtal" {dev = 6; shiftfields(1); device(); next}
$1 == "dio" {dev = 7; shiftfields(1); device(); next}
$1 == "sw" {dev = 8; shiftfields(1); device(); next}
$1 == "vnode" {dev = 9; shiftfields(1); device(); next}
$1 == "gnode" {dev = 10; shiftfields(1); device(); next}
$1 == "w" {dev = 11; shiftfields(1); device(); next}
$1 == "..." {dev = 12; shiftfields(1); device();next}
$1 == "b" {dev = 13; shiftfields(1); device();next}
$1 == "db9con" {dev = 14; shiftfields(1); device();next}

/.cktend/ {
}

function dot() {
	head = ""; body = ""; tail = "";
	raw_device_in = $0;
	n_fields = split(raw_device_in, cmd_fields, " ");
	head = sprintf ("%s: ", cmd_fields[1]);
	body = sprintf ("");
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function device() {
	head = ""; body = ""; tail = "";
	gsub(/\*/,".P", $0);
	gsub(/\~/,"_S", $0);
	raw_device_in = $0;

	n_fields = split(raw_device_in, cmd_fields, " ");
	sub(/\</, "", cmd_fields[1]);
	sub(/\>/, "", cmd_fields[1]);
	n_dev_parameters = split(cmd_fields[1], dev_parameters, ",")
	if(dev == 1) {
		res_device();
	}
	if(dev == 2) {
		cap_device();
	}
	if(dev == 3) {
		bjt_device();
	}
	if(dev == 4) {
		ic_device();
	}
	if(dev == 5) {
		header_device();
	}
	if(dev == 6) {
		xtal_device();
	}
	if(dev == 7) {
		dio_device();
	}
	if(dev == 8) {
		switch_device();
	}
	if(dev == 9) {
		vnode_device();
	}
	if(dev == 10) {
		gnd_device();
	}
	if(dev == 11) {
		net_device();
	}
	if(dev == 12) {
		dot();
	}
	if(dev == 13) {
		bus();
	}
	if(dev == 14) {
		db9_device();
	}
}

function res_device() {
	head = sprintf ("%s: resistor%d", dev_parameters[1], 
							dev_parameters[3]);
	body = sprintf ("(\"%s\", \"%s\")", dev_parameters[1], 
							dev_parameters[2]);
	if (cmd_fields[2] == "@") {
 		#sector_x = substr(cmd_fields[3], 1,1);
		#sector_y = deltasector_y * substr(cmd_fields[3], 2,1);
		#sector_x = deltasector_x * lettertoi(sector_x);
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function cap_device() {
	print "\#" $0
	head = sprintf ("%s: capacitor%d", dev_parameters[1], 
							dev_parameters[3]);
	body = sprintf ("(\"%s\",\"%s\",%s)", dev_parameters[1], 
					dev_parameters[2], dev_parameters[4]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function bjt_device() {
	print "\#" $0
	head = sprintf ("%s: bjt%d", dev_parameters[1], 
							dev_parameters[3]);
	body = sprintf ("(\"%s\",\"%s\",%s,%s)", dev_parameters[1], 
					dev_parameters[2], dev_parameters[4], 
					dev_parameters[5]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function ic_device() {
	head = sprintf ("%s: %s", dev_parameters[1], 
							dev_parameters[2]);
	body = sprintf ("(\"%s\")", dev_parameters[1]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
		for(i = 4; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function header_device() {
	head = sprintf ("%s: header%d", dev_parameters[1], 
					dev_parameters[3]);
	body = sprintf ("(\"%s\", %d)", dev_parameters[1], 
							dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function xtal_device() {
	head = sprintf ("%s: crystal%d", dev_parameters[1], 
							dev_parameters[3]);
	body = sprintf ("(\"%s\",\"%s\")", dev_parameters[1],
					dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function dio_device() {
	head = sprintf ("%s: diode%d", dev_parameters[1], 
							dev_parameters[3]);
	body = sprintf ("(\"%s\",\"%s\")", dev_parameters[1],
					dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function switch_device() {
	head = sprintf ("%s: switch%d", dev_parameters[1], 
							dev_parameters[3]);
	body = sprintf ("(\"%s\",\"%s\")", dev_parameters[1],
					dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function vnode_device() {
	head = sprintf ("%s: voltage1", dev_parameters[1]);
	body = sprintf ("(\"%s\")", dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function gnd_device() {
	head = sprintf ("%s: ground1", dev_parameters[1]);
	body = sprintf ("(\"%s\")", dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function db9_device() {
	head = sprintf ("%s: db9con1", dev_parameters[1]);
	body = sprintf ("(\"%s\",\"%s\")", dev_parameters[1], dev_parameters[2]);
	if (cmd_fields[2] == "@") {
		page_sector = sectorize(cmd_fields[3]);
		tail = sprintf("with .c at");
		tail = sprintf("%s (%s) ",tail, page_sector);
	} else
		for(i = 2; i <= n_fields; i++) 
			tail = sprintf("%s %s", tail, cmd_fields[i]);
	printf("%s%s %s\n", head, body, tail);
}

function net_device() {
	if(lastname == netname)	n_name++;
	else { lastname = netname; n_name = 0;}
	name = sprintf("%s_%d", netname, n_name);
	if(show_node == "hide" || cmd_fields[6] == "hide") 
		strname = "\"\"";
	else strname = sprintf("\"%s\"", name); 
	if(cmd_fields[3] != "") type = cmd_fields[3];
	if(cmd_fields[4] != "") loop = cmd_fields[4];
	if(cmd_fields[5] != "") dotted = cmd_fields[5];
	head = sprintf ("wire%d", type);
	body = sprintf ("(%s,%s,%s,%s,%f,%f)", name, strname, cmd_fields[1],
					cmd_fields[2],
					loop, dotted);
	
	tail = "";
	printf("%s%s %s\n", head, body, tail);
}

function bus() {
	head = sprintf ("wire%d", cmd_fields[6]);
	n = cmd_fields[7];
	sub(/\[|\]/,"",cmd_fields[2]);
	sub(/\[|\]/,"",cmd_fields[4]);
	sub(/\[|\]/,"",cmd_fields[5]);
	split(cmd_fields[2], from_fld,",");
	split(cmd_fields[4], to_fld,",");
	split(cmd_fields[5], loop_fld,",");
	from_pin = from_fld[1] * 1;
	from_pin_steps = from_fld[2];
	to_pin = to_fld[1] * 1;
	to_pin_steps = to_fld[2] * 1;
	loop = loop_fld[1] * 1;
	loop_steps = loop_fld[2] * 1;
	for(i = 1; i <= n; i++){
		if(lastname == netname)	n_name++;
		else { lastname = netname; n_name = 0;}
		name = sprintf("%s_%d", netname, n_name);
		if(show_node == "hide" || cmd_fields[8] == "hide") 
				strname = "\"\"";
		else strname = sprintf("\"%s\"", name); 
		type = cmd_fields[6];
		dotted = cmd_fields[8];
		head = sprintf ("wire%d", type);
		body = sprintf ("(%s,%s,%s.P%d,%s.P%d,%f,%f)", name, strname, 
					cmd_fields[1], from_pin, cmd_fields[3], to_pin,
					loop, dotted);
	
		tail = "";
		printf("%s%s %s\n", head, body, tail);
		from_pin = from_pin + from_pin_steps;
		to_pin = to_pin + to_pin_steps;
		loop = loop + loop_steps;
	}
}


function error(s) {
	printf "schem: error on line %d: %s\n", lineno, s | "cat 1>&2"
}

function warn(s) {
	printf "schem: warning on line %d: %s\n", lineno, s | "cat 1>&2"
}